<Query Kind="Program" />

// An in parameter is similar to a ref parameter except that the argument’s value cannot modified by the method.
// This is useful when passing a large value type to the method because it allows the compiler to avoid the overhead
// of copying the argument prior to passing it in while still protecting the original value from modification.

void Main()
{
	SomeBigStruct x = default;
	
	Foo (x);      // Calls the first overload
	Foo (in x);   // Calls the second overload

	Bar (x);      // OK (calls the 'in' overload)
	Bar (in x);   // OK (calls the 'in' overload)
}

void Foo (SomeBigStruct a)    => "Foo".Dump();
void Foo (in SomeBigStruct a) => "in Foo".Dump();

void Bar (in SomeBigStruct a) => "in Bar".Dump();

struct SomeBigStruct
{
	public decimal A, B, C, D, E, F, G;
}