<Query Kind="Statements" />

new Person1 ("Alice", "Jones").Print();   // Alice Jones
new Person2 ("Alice", "Jones").Print();   // Alice JONES
var p3 = new Person3 ("Alice", null);     // throws ArgumentNullException

class Person1 (string firstName, string lastName)
{
	// Sometimes it’s useful to perform computation in field initializers: 
	public readonly string FullName = firstName + " " + lastName;

	public void Print() => Console.WriteLine (FullName);
}

class Person2 (string firstName, string lastName)
{
	// Save an uppercase version of lastName to a field of the same name
	// (masking the original value):
	readonly string lastName = lastName.ToUpper();
	
	public void Print() => Console.WriteLine (firstName + " " + lastName);
}

class Person3 (string firstName, string lastName)
{
	// Validate lastName upon construction, ensuring that it cannot be null:
	readonly string lastName = (lastName == null)
		? throw new ArgumentNullException ("lastName")
		: lastName;
		
	public void Print() => Console.WriteLine (firstName + " " + lastName);
}
