<Query Kind="Statements">
  <Namespace>System.Collections.Immutable</Namespace>
</Query>

// Collection expressions are target-typed, meaning that the type of [1,2,3] depends on the
// type to which it’s assigned. This means that you can omit the type in other scenarios 
// where the compiler can infer it, such as when calling methods:

Foo ([1, 2, 3]);

void Foo (List<int> numbers) => numbers.Dump();

// In the following example, we export timezones to Excel using LINQPad's ToSpreadsheet extension method,
// specifying the particular columns to include.

TimeZoneInfo.GetSystemTimeZones().ToSpreadsheet (membersToInclude: ["Id", "DisplayName", "BaseUtcOffset"]).Open();