<Query Kind="Statements">
  <RuntimeVersion>8.0</RuntimeVersion>
</Query>

using System.Collections.Frozen;

// Frozen collections are great for lookups that are initialized at the start of
// a program and then used throughout the life of the application.

Disassembler.OpCodeLookup ["AND"].Dump();

class Disassembler
{
	public readonly static IReadOnlyDictionary<string, string> OpCodeLookup =
		new Dictionary<string, string>()
		{
			{ "ADC", "Add with Carry" },
			{ "ADD", "Add" },
			{ "AND", "Logical AND" },
			{ "ANDN", "Logical AND NOT" }
		}
		.ToFrozenDictionary (StringComparer.OrdinalIgnoreCase);
}
